# coding:utf-8
import threading
from Queue import *

from mongohand import *
from toolhand import *


class multigeturl(threading.Thread):
    global temp

    def __init__(self, queue, threadname, logger, lock):
        threading.Thread.__init__(self, name=threadname)
        self.queue = queue
        self.lock = lock
        self.logger = logger
        self.tmp = []

    def run(self):
        while True:
            info = self.queue.get()
            if self.lock.locked() or len(self.tmp) == 0:
                self.tmp.append(info)
            else:
                self.lock.acquire()
                db = mongohand(self.logger)
                db.dbconnect()
                self.logger.info(info)
                print info, self.getName()
                for tt in self.tmp:
                    allstar(tt, db)
                self.tmp = []
                self.lock.release()
            self.tmp.append(info)
            self.queue.task_done()
        self.queue.task_done()


def main():
    starturl = "https://www.ithome.com/html/win10/312982.htm"
    logop = {}
    logop['logfile'] = "log.txt"  # uop['logfile']
    logop['loglevel'] = "INFO"  # uop['level']
    global logger
    logger = getlog(logop)  # 构造log对象
    global db
    db = mongohand(logger)
    db.dbconnect()
    db.insertone(starturl)
    queue = Queue()

    allurl = db.selecturls()
    while len(allurl) > 0:
        t = allurl.pop()
        queue.put(t)
    # 初始化线程池
    threadnumber = 30
    lock = threading.Lock()
    for i in range(threadnumber):
        t1 = multigeturl(queue, 'urlt_' + str(i), logger, lock)
        t1.setDaemon(True)
        t1.start()

    while True:
        while len(allurl) > 0:
            t = allurl.pop()
            queue.put(t)
        allurl = db.selecturls()
        queue.join()


if __name__ == "__main__":
    main()
