# coding:utf-8
import time

from pymongo import MongoClient


class mongohand:
    def __init__(self, logger):
        self.logger = logger

    def dbconnect(self):
        self.dbcon = None
        try:
            client = MongoClient('120.26.233.25', 27017)
            db = client['try']
            db.authenticate('try', 'try')
            self.con = db.ithome
        except:
            self.logger.warn("数据库连接失败")
            print("数据库连接失败")
            quit()

    def insertone(self, url):
        if url is None: return
        info = {'_id': url, 'url': url, 'response': 0,
                'create_time': time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time()))}
        try:
            self.con.insert(info)
        except:
            pass

    def updateone(self, info):
        if 'url' not in info.keys(): return
        if info['comments'] is None or len(info['comments']) == 0:
            self.logger.warn("获取评论失败")
            print("获取评论失败")
            return
        info['update_time'] = time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time()))
        self.con.update({'_id': info['url']}, {'$set': info})

    def selecturls(self):
        allurl = []
        res = self.con.find({"response": 0}).limit(10)
        for r in res:
            allurl.append(r)
        return allurl
